from Products.PloneMallRegistry.MallRegistry import FactoryRegistry

def addPaymentInformation(order, method, factoryName='AuthorizeNetPaymentInformation', factory=None ):
    if not factory:
        factory = FactoryRegistry.getMallFactory(factoryName)
    id = 'payment_information'
    obj = factory(id)
    order._setObject(id, obj)
    obj = getattr(order, id)
    if type(method) in (type(()),type([])):
        obj.setMethod_name(method)
    else:
        obj.setMethod_name(method.__class__.__name__)
    #obj.setProcessed(1)
    total=order.getTotal()
    #import pdb;pdb.set_trace()
    obj.update(value=total.getValue(),currency=total.getCurrencySymbol())
    order.setPayment(obj)
    # for now we have only one address
    order.setPaymentAddress(order.getCustomerAddress())
    return obj
